////////////////////////////////////////////////////////////////////////////
// Rev: 2010.1 (P4JsApi 1.0 Example)
//
// NOTE: This is an example only, and should be modified to work in
// a production environment! No warranty is expressed or implied.
// Scripts should be tested thoroughly on a test server before
// using in a production environment.
//
////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010, Perforce Software, Inc.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1.  Redistributions of source code must retain the above copyright
//     notice, this list of conditions and the following disclaimer.
//
// 2.  Redistributions in binary form must reproduce the above copyright
//     notice, this list of conditions and the following disclaimer in the
//     documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////

var P4 = P4 || {};

P4.createLicenseWidget = function(container) {
    try {
        if (!container) {
            return;
        }
        var mask = new Ext.LoadMask(Ext.get(container), {
            msg: "Loading...",
            removeMask: true
        });
        mask.show();

        P4JsApi.p4("info",

        function(info) {
            var max = 0;
            if (info && info.data[0] && info.data[0].serverLicense) {
                max = info.data[0].serverLicense.match(/(\d+) users/)[1];
            }

            P4JsApi.p4("users",

            function(users) {
                var current = 0;
                while (users.data[current]) {
                    current++;
                }

                var data = new google.visualization.DataTable();
                data.addColumn('string', 'Label');
                data.addColumn('number', 'Value');
                data.addRows(1);
                data.setValue(0, 0, 'Users');
                data.setValue(0, 1, current);

                var chart = new google.visualization.Gauge(document.getElementById(container));
                var options = {
                    width: 200,
                    height: 150,
                    redFrom: max * .9,
                    redTo: max,
                    yellowFrom: max * .8,
                    yellowTo: max * .9,
                    minorTicks: 5,
                    max: max
                };

                mask.hide();
                chart.draw(data, options);
            });
        });
    } catch(e) {
        alert(e);
    }
}